package com.zcloud.controller.bus;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import org.apache.shiro.authz.annotation.RequiresPermissions;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import com.zcloud.entity.PageData;
import com.zcloud.entity.system.Dictionaries;
import com.zcloud.entity.system.Role;
import com.zcloud.service.bus.CorpInfoService;
import com.zcloud.service.bus.SMSManagementService;
import com.zcloud.service.system.DictionariesService;
import com.zcloud.service.system.RoleService;
import com.zcloud.service.system.UsersService;

/** 
 * 说明：短信管理
 * 作者：luoxiaobao
 * 时间：2021-01-21
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/smsmanagement")
public class SMSManagementController extends BaseController {
	
	@Autowired
	private SMSManagementService smsmanagementService;

	@Autowired
	private DictionariesService dictionariesService;

	@Autowired
	private CorpInfoService corpinfoService;
	@Autowired
    private UsersService usersService;
	@Autowired
    private RoleService roleService;
	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	@RequiresPermissions("smsmanagement:add")
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		
		List<PageData>	smsList = smsmanagementService.listAll(pd);
		if(smsList.size()>0) {
			errInfo="chongfu";
		}else {
			pd.put("SMSMANAGEMENT_ID", this.get32UUID());	//主键
			pd.put("OPDATE", DateUtil.date2Str(new Date()));	//操作日期
			pd.put("OPUSER", Jurisdiction.getUsername());	//操作人
			pd.put("ISDELETE", "0");	//是否删除
			pd.put("OPERATOR", Jurisdiction.getUsername());	
			pd.put("ISENABLE", "0");	
			pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	
			smsmanagementService.save(pd);
		}
		map.put("result", errInfo);
		return map;
	}
	@RequestMapping("/userlist")
	@ResponseBody
	public Object listUsers(Page page)throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		
		/*检索条件*/
		String ROLE_ID = pd.getString("ROLE_ID");						//角色ID
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		String DEPARTMENT_ID = pd.getString("DEPARTMENT_ID");						//关键词检索条件
		if(Tools.notEmpty(DEPARTMENT_ID))pd.put("DEPARTMENT_ID", DEPARTMENT_ID.trim());
		String STRARTTIME = pd.getString("STRARTTIME");					//开始时间
		String ENDTIME = pd.getString("ENDTIME");						//结束时间
		if(Tools.notEmpty(STRARTTIME))pd.put("STRARTTIME", STRARTTIME+" 00:00:00");
		if(Tools.notEmpty(ENDTIME))pd.put("ENDTIME", ENDTIME+" 00:00:00");
		pd.put("CORPINFO_ID",pd.getString("CORPINFO_ID"));
		page.setPd(pd);
		List<PageData>	userList = usersService.userlistPage(page);		//列出用户列表
		pd.put("ROLE_ID", "1");
		List<Role> roleList = roleService.listAllRolesByPId(pd);		//列出所有系统用户角色
		
		map.put("userList", userList);
		map.put("roleList", roleList);
		map.put("ROLE_ID", ROLE_ID);
		map.put("page", page);
		map.put("pd", pd);

		map.put("result", errInfo);
		return map;
	}
	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	@RequiresPermissions("smsmanagement:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		smsmanagementService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}
	@RequestMapping(value="/editIsEnable")
	@ResponseBody
	public Object editIsEnable() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd=smsmanagementService.findById(pd);
		if(pd.get("ISENABLE").toString().equals("1")) {
			pd.put("ISENABLE", "0");
		}else {
			pd.put("ISENABLE", "1");
		}
		smsmanagementService.editIsEnable(pd);
		map.put("pd",pd);
		map.put("result", errInfo);
		return map;
	}
	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	@RequiresPermissions("smsmanagement:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		smsmanagementService.edit(pd);
		map.put("result", errInfo);
		return map;
	}
	
	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	@RequiresPermissions("smsmanagement:list")
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CREATOR", Jurisdiction.getUsername());
		page.setPd(pd);
		List<PageData>	varList = smsmanagementService.list(page);	//列出SMSManagement列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}
	
	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	@RequiresPermissions("smsmanagement:edit")
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = smsmanagementService.findById(pd);	//根据ID读取
		List<Dictionaries>	varList = dictionariesService.listSubDictByParentId("514042127588463bba0bec45e982d42f");
	
		List<PageData>	corpinfoList=corpinfoService.listAll(pd);
		map.put("pd", pd);
		map.put("varList", varList);
		map.put("corpinfoList", corpinfoList);
		map.put("result", errInfo);
		return map;
	}	
	
	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	@RequiresPermissions("smsmanagement:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();		
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			smsmanagementService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}
	
	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	@RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("名称");	//1
		titles.add("编码");	//2
		titles.add("类型");	//3
		titles.add("收信人");	//4
		titles.add("是否启用");	//5
		titles.add("企业ID");	//6
		titles.add("操作日期");	//7
		titles.add("操作人");	//8
		titles.add("是否删除");	//9
		titles.add("修改人");	//10
		titles.add("修改日期");	//11
		dataMap.put("titles", titles);
		List<PageData> varOList = smsmanagementService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("SMSNAME"));	    //1
			vpd.put("var2", varOList.get(i).getString("SMSCODE"));	    //2
			vpd.put("var3", varOList.get(i).getString("SMSTYPE"));	    //3
			vpd.put("var4", varOList.get(i).getString("ADDRESSEE"));	    //4
			vpd.put("var5", varOList.get(i).getString("ISENABLE"));	    //5
			vpd.put("var6", varOList.get(i).getString("CORPINFO_ID"));	    //6
			vpd.put("var7", varOList.get(i).getString("OPDATE"));	    //7
			vpd.put("var8", varOList.get(i).getString("OPUSER"));	    //8
			vpd.put("var9", varOList.get(i).getString("ISDELETE"));	    //9
			vpd.put("var10", varOList.get(i).getString("OPERATOR"));	    //10
			vpd.put("var11", varOList.get(i).getString("OPERATTIME"));	    //11
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}
	
}
